"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("./requireModule");
var generator_1 = require("./generator");
var generator_2 = require("./generator");
var pkg = requireModule_1.default('./package.json');
var spinConfig = pkg.spin;
var createConfig = function (cmd) {
    var config = {};
    var options = spinConfig.options;
    try {
        options.backendBuildDir = options.backendBuildDir || 'build/server';
        options.frontendBuildDir = options.frontendBuildDir || 'build/client';
        options.dllBuildDir = options.dllBuildDir || 'build/dll';
        options.webpackDevPort = options.webpackDevPort || 3000;
        for (var _i = 0, _a = Object.keys(spinConfig.presets); _i < _a.length; _i++) {
            var preset = _a[_i];
            var platform = new generator_2.Platform(preset);
            if (spinConfig.presets[preset]) {
                var dev = cmd === 'watch' || cmd === 'test';
                if (cmd === 'test' && !platform.hasAny('test'))
                    continue;
                config[preset] = generator_1.default(preset, dev, options, {});
                if (options.webpackDll && !platform.hasAny('server')) {
                    config[preset + "-dll"] = generator_1.default(preset + "-dll", dev, options, {});
                }
            }
        }
    }
    catch (e) {
        console.error(e.stack);
    }
    return { config: config, options: options };
};
exports.default = createConfig;
//# sourceMappingURL=config.js.map