"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Platform = (function () {
    function Platform() {
        var features = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            features[_i] = arguments[_i];
        }
        this.features = features.reduce(function (acc, feature) {
            if (!feature) {
                return acc;
            }
            else if (feature.constructor === Array) {
                return acc.concat(feature);
            }
            else {
                return acc.concat(feature.split(':'));
            }
        }, []);
        if (this.hasAny('server')) {
            this.target = 'server';
        }
        else if (this.hasAny('web')) {
            this.target = 'web';
        }
        else if (this.hasAny('android')) {
            this.target = 'android';
        }
        else if (this.hasAny('ios')) {
            this.target = 'ios';
        }
    }
    Platform.prototype.hasAny = function (arg) {
        var array = arg.constructor === Array ? arg : [arg];
        for (var _i = 0, array_1 = array; _i < array_1.length; _i++) {
            var feature = array_1[_i];
            if (this.features.indexOf(feature) >= 0) {
                return true;
            }
        }
        return false;
    };
    return Platform;
}());
exports.default = Platform;
//# sourceMappingURL=platform.js.map